<div>
  <a href="https://twitter.com/microhq"><img src="https://img.shields.io/twitter/follow/microhq?label=microhq&style=social" /></a>
  <a href="https://github.com/micro/micro/network/members"><img src="https://img.shields.io/github/forks/micro/micro?style=social" /></a>
  <a href="https://github.com/micro/micro/stargazers"><img src="https://img.shields.io/github/stars/micro/micro?style=social" /></a>
</div>

<div style="border: 1px solid #333333">
  <img src="{{ site.baseurl }}/images/banner.png" />
</div>

## Overview

Micro addresses the key requirements for building services in the cloud. It leverages the microservices
architecture pattern and provides a set of services which act as the building blocks of a platform. Micro deals
with the complexity of distributed systems and provides simpler programmable abstractions to build on. 

## Source

[GitHub Repo](https://github.com/micro/micro)

## Download

[Latest Release](https://github.com/micro/micro/releases/latest)

## Content

Documentation, guides and quick starts for Micro

- [Introduction](introduction) - A high level introduction to Micro
- [Getting Started](getting-started) - The helloworld quickstart guide
- [Upgrade Guide](upgrade-guide) - Update your go-micro project to use micro v3.
- [Architecture](architecture) - Describes the architecture, design and tradeoffs
- [Reference](reference) - In-depth reference for Micro CLI and services
- [Resources](resources) - External resources and contributions
- [Roadmap](roadmap) - Stuff on our agenda over the long haul
- [Users](users) - Developers and companies using Micro in production
- [FAQ](faq) - Frequently asked questions
- [Blog](blog) - For the latest from us

## Contributing

See the [TODO](/todo) list, open a PR and start hacking away at the docs.

## Community

Join us on [Slack](https://slack.micro.mu). Follow [@microhq](https://twitter.com/microhq) on Twitter for updates.

## Hosting

For a hosted Micro Platform aka M3O see [m3o.com](https://m3o.com).

## License

[Polyform Shield](https://polyformproject.org/licenses/shield/1.0.0/)
